package eqsat.engine;

public enum AxiomGroup {
	////// EngineAxioms //////
	
	// addAxioms
	BOOLEAN_NEGATING_AXIOMS,
	BOOLEAN_STRUCTURES_AXIOMS,
	EQUALITY_AXIOMS,
	PHI_AXIOMS,
	
	// addLoopAxioms
	INDUCTION_AXIOMS,
	EVAL_INVARIANT_AXIOMS,
	INVARIANT_EVAL_AXIOMS,
	EVAL_SUCC_SHIFT_AXIOMS,
	EVAL0_THETA_AXIOMS,
	THETA_EVAL0_AXIOMS,
	JOIN_THETA_AXIOMS,
	TIGHT_THETA_AXIOMS,
	PASS_THETA_TRUE_AXIOMS,
	PASS_THETA_FALSE_AXIOMS,
	INVARIANT_PASS_AXIOMS,
	PASS_TRUE_AXIOMS,
	PEEL_PASS_AXIOMS,
	SHIFT_INVARIANT_AXIOMS,
	SHIFT_EVAL_AXIOMS,
	SHIFT_THETA_AXIOMS,
	
	// addVariaticAxioms
	DISTRIBUTE_THROUGH_PHI_AXIOMS,

	// addVariaticLoopAxioms
	INFER_INVARIANCE_AXIOMS,
	DISTRIBUTE_SHIFT_AXIOMS,
	DISTRIBUTE_EVAL_AXIOMS,
	DISTRIBUTE_EVAL0_AXIOMS,
	DISTRIBUTE_THROUGH_EVAL_AXIOMS,
	DISTRIBUTE_THROUGH_THETA_AXIOMS,
	UNDISTRIBUTE_THROUGH_THETA_AXIOMS,
	
	// addVariaticLoopInteractionAxioms
	INTERACTION_DISTRIBUTE_EVAL_1_AXIOMS,
	INTERACTION_DISTRIBUTE_EVAL_2_AXIOMS,
	INTERACTION_DISTRIBUTE_THROUGH_EVAL_1_AXIOMS,
	INTERACTION_DISTRIBUTE_THROUGH_EVAL_2_AXIOMS,
	
	
	////// SimpleEngine //////
	
	// addAxioms()
	CONSTANTS_NOT_EQUAL_AXIOMS,
	
	// addLoopAxioms
	MONITOR_INVARIANCE_AXIOMS,
	
	// addVariaticAxioms(int)
	CUSTOM_VARIATIC_AXIOMS,
	CONSTANT_FOLD_AXIOMS,
}
